#include <Servo.h>          //se incluye la libreria para usar los servos

Servo servo1;               //definicion de los 4 servos
Servo servo2;
Servo servo3;
Servo servo4;

char ordre;                 //variable de ordenes de movimiento
int s1=0, s2=0, s3=0, s4=0; //variables del angulo de los servos
bool token=false;           //variable de llegada de ordenes
int GiroMaximo;             //variable auxiliar de limite de giro
                            //se usa en el switch case con una formula
                            //distinta en cada caso


void setup() 
{
  Serial.begin(9600);       //inicialización del bus serial
  
  servo1.attach(9);         //definicion de los pines PWM de cada servo
  servo2.attach(10);
  servo3.attach(11);
  servo4.attach(3);
  
  pinMode(7, INPUT);
  //servos en posicion de reposo. Los calculos se realizan
  //con el 0 como posicion central (rango de -90 a 90)
  //pero los servos entienden por posicion neutral 
  //el 90 (rango de 0 a 180)
  servo1.write(s1+90);
  servo2.write(s2+90);
  servo3.write(s3+90);
  servo4.write(s4+90);

}

void loop() {
  //si hay datos en el bus serial
  //se guardan en la variable ordre
  //y se canvia el token a true
  if (Serial.available()) {
    ordre = Serial.read();
    token=true;
  }
  switch (ordre){
    case 'A': //A=abrir
      Serial.println("obrir");
      s4=165; //angulo max de la mano = 75+90
      break;
    case 'C': //C=cerrar
      Serial.println("tancar");
      s4=70;  //angulo min de la mano = -20+90
      break;
    case 'Y': //Y=yaw horario; s1 y s2 giran simetricamente, s3 quieto
      Serial.println("YAW");
      GiroMaximo = 20+min(70+s2,70-s1);
      s2=s2-GiroMaximo;
      s1=s1+GiroMaximo;
      break;
    case 'y': //y=yaw antihorario; s1 y s2 giran simetricamente, s3 quieto
      Serial.println("yaw");
      GiroMaximo = 20+min(70-s2,70+s1);
      s2=s2+GiroMaximo;
      s1=s1-GiroMaximo;
      break;
    case 'R': //R=roll horario; s1, s2, s3 giran solidarios
      Serial.println("ROLL");
        GiroMaximo = 90-max(max(max(s1,s2),s3),0);
        s1=s1+GiroMaximo;
        s2=s2+GiroMaximo;
        s3=s3+GiroMaximo;
      break;
    case 'r':: //r=roll antihorario; s1, s2, s3 giran solidarios
      Serial.println("roll");
        GiroMaximo = 90+min(min(min(s1,s2),s3),0);
        s1=s1-GiroMaximo;
        s2=s2-GiroMaximo;
        s3=s3-GiroMaximo;
      break;
    case 'O': //O=posicion de origen
      Serial.println("Inicio");
      s1=0;
      s2=0;
      s3=0;
      s4=90;
      break;   
  }
      //si el token esta activo se escrive la nueva posición de
      //cada servo y se desactiva el token;
      //a la posicon se le seve sumar 90 ya que estan referenciados
      //con el 90 en la posicion central
      if(token){
        servo1.write(s1+90);
        servo2.write(s2+90);
        servo3.write(s3+90);
        servo4.write(s4);
        token=false;
        Serial.println(s1);
        Serial.println(s2);
        Serial.println(s3);
        Serial.println(s4);
      }
}
